// Generated by CoffeeScript 1.3.3

define(['jquery', 'underscore'], function($, _) {
  var coerceValue, getInputValue, setInputValue, validateValue;
  getInputValue = function($el) {
    var e, multi, value;
    multi = false;
    $el = $el.not(':disabled');
    if ($el.is('input[type=checkbox]') && $el.length > 1) {
      multi = true;
    }
    if ($el.is('input[type=radio],input[type=checkbox]')) {
      $el = $el.filter(':checked');
    }
    if ($el.is('select[multiple]')) {
      multi = true;
      value = $el.val();
    } else if (multi || $el.length > 1) {
      multi = true;
      value = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = $el.length; _i < _len; _i++) {
          e = $el[_i];
          _results.push($(e).val());
        }
        return _results;
      })();
    } else {
      value = $el.val();
    }
    if (!(value != null) || value === '') {
      value = multi ? [] : null;
    }
    return value;
  };
  setInputValue = function($el, value) {
    var i, multi, x, _i, _len;
    multi = false;
    if ($el.is('select[multiple],input[type=radio],input[type=checkbox]')) {
      multi = true;
    }
    if (!multi && $el.length > 1) {
      if (!_.isArray(value)) {
        value = [value];
      }
      for (i = _i = 0, _len = value.length; _i < _len; i = ++_i) {
        x = value[i];
        $($el[i]).val(x);
      }
      return;
    }
    if (multi && !_.isArray(value)) {
      value = [value];
    } else if (!multi && _.isArray(value)) {
      value = value[0];
    }
    $el.val(value);
  };
  coerceValue = function(value, type) {
    var cleaned, x, _i, _len;
    if (!(value != null) || value === '') {
      return null;
    }
    if (_.isArray(value)) {
      cleaned = [];
      for (_i = 0, _len = value.length; _i < _len; _i++) {
        x = value[_i];
        if ((x = coerceValue(x, type))) {
          cleaned.push(x);
        }
      }
      if (cleaned.length) {
        return cleaned;
      } else {
        return null;
      }
    } else {
      switch (type) {
        case 'boolean':
          switch (value) {
            case true:
            case 1:
            case 'true':
            case '1':
              return true;
            case false:
            case 0:
            case 'false':
            case '0':
              return false;
          }
          break;
        case 'number':
          return parseFloat(value);
        case 'string':
          return value.toString();
        case 'date':
        case 'datetime':
        case 'time':
          return Date.parse(value);
      }
    }
  };
  validateValue = function(value, type) {
    switch (type) {
      case 'boolean':
        return _.isBoolean(value);
      case 'number':
        return _.isNumber(value);
      case 'string':
        return _.isString(value);
      case 'date':
      case 'datetime':
      case 'time':
        return _.isDate(value);
      default:
        return false;
    }
  };
  return {
    getInputValue: getInputValue,
    setInputValue: setInputValue,
    coerceValue: coerceValue,
    validateValue: validateValue
  };
});
